;Faculdade de Arquitetura de Lisboa
;Modelação e Visualização Tridimensional em Arquitetura
;2ºsemestre - Ano letivo 2022-2023
;Docente: Luís Romão


;Comando proposto pela aluna Beatriz Gomes-20191184
 
 
;Macro destinada a desenhar a escada do meu pormenor construtivo (em milimetros)
;a escada é constituída por dois lances e um patamar 

;nome do comando
(defun c:escadas ()
(setq ponto (getvar "osmode"))
(setq 3dponto (getvar "3DOSMODE"))
(setvar "osmode" 0)
(setvar "3dosmode" 0)
;é indicado o ponto de inserção
(setq pt1 (getpoint "Qual o ponto de inserção da escada?"))
(If (= nil
;é indicado a largura da escada
(setq largura (getreal "Qual a largura da escada?")))
(setq largura 935))
(If (= nil
;é indicado o cobertor do degrau
(setq cobertor (getreal "Qual a dimensao do cobertor?")))
(setq cobertor 340))
(If (= nil
;é indicada a espessura do degrau
(setq espessura (getreal "Qual a espessura do degrau?")))
(setq espessura 63.5))
(If (= nil
;é indicado o dimensao do espelho do degrau
(setq espelho (getreal "Qual a dimensao do espelho?")))
(setq espelho 135.4))
(If (= nil
;é indicado o número de degraus do primeiro lance de escadas
(setq degraus (getint "Qual o número de degraus do primeiro lance?")))
(setq degraus 12))
(If (= nil
;é indicado o comprimento do patamar
(setq patamar (getreal "Qual o comprimento do patamar?")))
(setq patamar 4302))
(If (= nil
;é indicado o número de degraus do segundo lance de escadas
(setq degraus2 (getint "Qual o número do segundo lance?")))
(setq degraus2 7))

(command "ucs" pt1 "")

;definicao do pontos para definir o degrau

;definicao do ponto 2 a partir das coordenadas x e y do ponto 1 e da largura da escada
(setq pt2 (list (car pt1) (+ (cadr pt1) largura) espelho))

;definicao do ponto 3 a partir das coordenadas x e y do ponto 2 e da dimensao do cobertor
(setq pt3 (list (+ (car pt2) cobertor)(cadr pt2) espelho))

;definicao do ponto 4 a partir da coordenada x do ponto 3 e da coordenada y do ponto 1 
(setq pt4 (list (car pt3) (cadr pt1) espelho))

;definicao do primeiro ponto do patamar a apartir da soma da coordenada x do ponto 1 com a multiplicacao do numero de degraus pela dimensao do cobertor e da coordenada y do ponto 1 
(setq pt5 (list (+ (car pt1) (* degraus cobertor )) (cadr pt1) (* espelho (+ degraus 1))))

;definicao do comprimento do patamar a partir da soma da coordenada x do ponto 5 com a profundidade do patamar e da coordenada y do ponto 5 
(setq pt6 (list (+ (car pt5) patamar) (cadr pt5) (+ (caddr pt4) espelho)))

;definicao da largura do patamar (ponto 7) apartir da coordenada x do ponto 6 e da multiplicacao da largura x2
(setq pt7 (list (car pt6) (+ (cadr pt6) (* largura 2)) (+ (caddr pt4) espelho)))

;definicao do degrau
(command "rectang" pt2 pt4 "")

;definicao da espessura do degrau
(command "region" (entlast) "")
(command "extrude" (entlast) "" (* -1 espessura))

;definição do número de degraus do primeiro lance
(repeat (- degraus 1)
(command "copy" (entlast) "" pt1 pt4)
)
		
;definição do patamar
(command "rectang" pt5 pt7 "")

;definição da espessura do patamar
(command "region" (entlast) "")
(command "extrude" (entlast) "" (* -1 espessura))

;definição do degrau do segundo lance
(setq pt8 (list (car pt5) (+ (cadr pt5) (* largura 2)) (+ (caddr pt5) espelho)))
(setq pt9 (list (car pt5) (+ (cadr pt5) largura) (caddr pt5)))
(setq pt10 (list (- (car pt5) cobertor)(+ (cadr pt5) largura) (+ (caddr pt9) espelho)))
(command "rectang" pt8 pt10 "")

;definicão da espessura do degrau
(command "region" (entlast) "")
(command "extrude" (entlast) "" (* -1 espessura))

;definição do número de degrau do segundo lance
(repeat (- degraus2 1)
(command "copy" (entlast) "" pt9 pt10))


(command "mirror" (ssget "_A") "" (list 0 largura 0) (list largura largura 0) "y")
)